"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class CancerGermlineVariantLevelQuestionnaire(ProtocolElement):
    """
    A record holding the germline variant level questions for a single
    variant together with its normalized variant coordinates
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "variantCoordinates",
        "variantLevelQuestions",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_6_1 import reports as reports_5_0_0

        return {
            "variantCoordinates": reports_5_0_0.VariantCoordinates,
            "variantLevelQuestions": reports_5_0_0.CancerGermlineVariantLevelQuestions,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_6_1 import cva as cva_1_0_0
        from protocols.protocol_6_1 import reports as reports_5_0_0

        return {
            "org.gel.models.report.avro.VariantCoordinates": reports_5_0_0.VariantCoordinates,
            "org.gel.models.report.avro.CancerGermlineVariantLevelQuestions": reports_5_0_0.CancerGermlineVariantLevelQuestions,
            "org.gel.models.cva.avro.CancerGermlineVariantLevelQuestionnaire": cva_1_0_0.CancerGermlineVariantLevelQuestionnaire,
        }

    __slots__ = [
        "variantCoordinates",
        "variantLevelQuestions",
    ]

    def __init__(
        self,
        variantCoordinates,
        variantLevelQuestions,
        validate=None,
        **kwargs
    ):
        """Initialise the cva_1_0_0.CancerGermlineVariantLevelQuestionnaire model.

        :param variantCoordinates:
            The coordinates of a given variant: assembly, chromosome, position,
            reference and alternate
        :type variantCoordinates: VariantCoordinates
        :param variantLevelQuestions:
            The questions at variant level
        :type variantLevelQuestions: CancerGermlineVariantLevelQuestions
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.0.0"
